import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsForm, CmsFormParam } from './model';


/**
 * 分页查询表单设计表
 */
export async function pageCmsForm(params: CmsFormParam) {
  const res = await request.get<ApiResult<PageResult<CmsForm>>>(
    '/cms/cms-form/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询表单设计表列表
 */
export async function listCmsForm(params?: CmsFormParam) {
  const res = await request.get<ApiResult<CmsForm[]>>(
    '/cms/cms-form',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加表单设计表
 */
export async function addCmsForm(data: CmsForm) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-form',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改表单设计表
 */
export async function updateCmsForm(data: CmsForm) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-form',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除表单设计表
 */
export async function removeCmsForm(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-form/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除表单设计表
 */
export async function removeBatchCmsForm(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-form/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询表单设计表
 */
export async function getCmsForm(id: number) {
  const res = await request.get<ApiResult<CmsForm>>(
    '/cms/cms-form/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
